%define name Mesa
%define version 3.1beta1
%define release 3
%define major 3.1
%define serial 1

%define builddir $RPM_BUILD_DIR/%{name}-%{major}

Summary: A 3-D graphics library with an API very similar to OpenGL.

Name: %{name}
Version: %{version}
Release: %{release}
Serial: %{serial}
Group: Libraries
Copyright: GPL
Vendor: Brian Paul <brian_paul@avid.com>
Url: http://www.ssec.wisc.edu/~brianp/Mesa.html
Packager: Ryan Weaver <ryanw@infohwy.com>
Distribution: Freshmeat RPMs
Source0: ftp://iris.ssec.wisc.edu/pub/Mesa/MesaLib-%{version}.tar.gz
Source1: ftp://iris.ssec.wisc.edu/pub/Mesa/MesaDemos-%{version}.tar.gz
Patch0: Mesa-3.0-rh.patch
Buildroot: /tmp/%{name}-%{version}-%{release}-root

%description
The Mesa 3-D graphics library is a powerful and generic toolset
for creating hardware assisted computer graphics.  To the extent that Mesa
utilizes the OpenGL command syntax or state machine, it is being used with
authorization from Silicon Graphics, Inc.  However, the author (Brian Paul)
makes no claim that Mesa is in any way a compatible replacement for OpenGL
or associated with Silicon Graphics, Inc. Those who want a licensed
implementation of OpenGL should contact a licensed vendor.  However, Mesa is
very similar to OpenGL, and you might find Mesa to be a valid alternative to
OpenGL.

%package devel
Summary: The development environment for the Mesa 3-D graphics library.
Group: Developments/Libraries
Serial: %{serial}

%description devel
Mesa-devel contains the static version of the Mesa 3-D graphics
library (a graphics toolkit very similar to Silicon Graphics' OpenGL
graphics utilities toolkit) and includes files needed for development. If
you're going to develop Mesa applications, you'll need to install mesa-devel
along with mesa and possibly mesa-demos. If you're just going to use Mesa,
you don't need to install mesa-devel.


%package glut
Summary: The GLUT (OpenGL Utility Toolkit) library for Mesa/OpenGL 3-D graphics.
Group: X11/Libraries
Serial: %{serial}
Conflicts: glut

%description glut
Mesa-glut contains the GLUT (OpenGL Utility Toolkit) library.
GLUT is a window system independent toolkit for writing small to
medium-sized OpenGL programs.  OpenGL is a Silicon Graphics, Inc., graphics
utilities toolkit.  Since Mesa (a graphics library) is very similar to
OpenGL, OpenGL programs will work with Mesa.

GLUT is well-suited for learning OpenGL and developing simple OpenGL
applications, but it is not a full-featured toolkit.  If you're interested
in creating large applications requiring sophisticated user interfaces,
you're probably better off using a native window system toolkit like Motif.
If you're interested in learning how to create OpenGL applications or in
creating small and simple OpenGL applications, you should install mesa-glut
along with mesa and possibly mesa-demos.  You may also want to install
mesa-devel, which provides a development environment for Mesa programming.


%package glut-devel
Summary: The GLUT (OpenGL Utility Toolkit) development environment for Mesa/OpenGL 3-D graphics.
Group: Developments/Libraries
Serial: %{serial}
Conflicts: glut-devel

%description glut-devel
Mesa-glut-devel contains the static version of the GLUT (OpenGL
Utility Toolkit) library and includes files needed for GLUT development.
OpenGL is a Silicon Graphics, Inc., graphics utilities toolkit.  The Mesa
3-D graphics library is a freeware equivalent to OpenGL.  Both OpenGL and
Mesa work with GLUT.

You should install mesa-glut-devel if you want to develop GLUT programs. If
you install mesa-glut-devel, you also need to install mesa, mesa-glut, and
possibly mesa-demos.  If you also want to develop Mesa applications, you
need to also install mesa-devel.

%package demos
Summary: You guessed it, demonstration programs for the Mesa 3-D graphics library.
Serial: %{serial}
Group: Developments/Libraries

%description demos
Mesa-demos contains demonstration programs for the Mesa 3-D
graphics library (a graphics toolkit very similar to Silicon Graphics'
OpenGL).  You don't need to install mesa-demos if you're upgrading from a
previous version of Mesa, or if you just aren't interested in the
demonstrations.  If you're new to Mesa, however, you should install them
along with the mesa package.

%prep

%setup -q -n Mesa-3.1 -b 1

%patch0 -p1 -b .rh

%build

%ifarch alpha
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LIBS_ONLY=YES linux-alpha
make clean
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" linux-alpha-elf
%endif

%ifarch ppc
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" linux-ppc
%endif

%ifarch i386
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LIBS_ONLY=YES linux-386
make clean
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" linux-386-elf
%endif

%ifarch sparc
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" LIBS_ONLY=YES linux-sparc
make clean
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" linux-sparc-elf
%endif

cd widgets-mesa
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr
make 

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT ; fi
mkdir -p $RPM_BUILD_ROOT/usr/{lib/Mesa-%{major},include,man/man3}

cp -dpr lib include $RPM_BUILD_ROOT/usr
cp -dpr book demos xdemos samples util $RPM_BUILD_ROOT/usr/lib/Mesa-%{major}
cp Make-config $RPM_BUILD_ROOT/usr/lib/Mesa-%{major}

(
cd widgets-mesa
make prefix=$RPM_BUILD_ROOT/usr install
)

%clean
rm -r $RPM_BUILD_ROOT
rm -r %{builddir}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%attr(-, root, root) %doc FUTURE IAFA-PACKAGE LICENSE README* RELNOTES VERSIONS

%ifnarch ppc
%attr(755, root, bin) /usr/lib/libMesa*.so.*
%else
%attr(644, root, bin) /usr/lib/libMesa*.a
%endif

%files glut
%defattr(-,root,root)
%ifnarch ppc
%attr(755, root, bin) /usr/lib/libglut.so.*
%else
%attr(644, root, bin) /usr/lib/libglut.a
%endif

%files glut-devel
%defattr(-,root,root)
%ifnarch ppc
%attr(755, root, bin) /usr/lib/libglut.so
%attr(644, root, bin) /usr/lib/libglut.a
%endif
%attr(444, root, root) /usr/include/GL/glut.h

%files devel
%defattr(-,root,root)
%ifnarch ppc
%attr(755, root, bin) /usr/lib/libMesa*.so
%attr(644, root, bin) /usr/lib/libMesa*.a
%endif

%attr(755, root, root) %dir /usr/lib/Mesa-%{major}
%attr(644, root, root)      /usr/lib/Mesa-%{major}/Make-config
%attr(755, root, root) %dir /usr/lib/Mesa-%{major}/util
%attr(-, root, root)        /usr/lib/Mesa-%{major}/util/*

%attr(755, root, root) %dir /usr/include/GL
%attr(444, root, root) /usr/include/GL/GLw*.h
%attr(444, root, root) /usr/include/GL/Mesa*.h
%attr(444, root, root) /usr/include/GL/gl.h
%attr(444, root, root) /usr/include/GL/gl_mangle.h
%attr(444, root, root) /usr/include/GL/glu.h
%attr(444, root, root) /usr/include/GL/glu_mangle.h
%attr(444, root, root) /usr/include/GL/glx.h
%attr(444, root, root) /usr/include/GL/glx_mangle.h
%attr(444, root, root) /usr/include/GL/*mesa.h
%attr(444, root, man)  /usr/man/man?/*

%files demos
%defattr(-,root,root)
%attr(755, root, root) %dir /usr/lib/Mesa-%{major}/book
%attr(755, root, root) %dir /usr/lib/Mesa-%{major}/demos
%attr(755, root, root) %dir /usr/lib/Mesa-%{major}/samples
%attr(755, root, root) %dir /usr/lib/Mesa-%{major}/xdemos

%attr(-, root, root) /usr/lib/Mesa-%{major}/book/*
%attr(-, root, root) /usr/lib/Mesa-%{major}/demos/*
%attr(-, root, root) /usr/lib/Mesa-%{major}/samples/*
%attr(-, root, root) /usr/lib/Mesa-%{major}/xdemos/*

%changelog
* Fri Nov 20 1998 Ryan Weaver <ryanw@infohwy.com>
  [Mesa-3.1beta1-3]
- Split Packages.
- Added stuff from rawhide Mesa-3.0 spec file.

* Fri Nov 20 1998 Ryan Weaver <ryanw@infohwy.com>
  [Mesa-3.1beta1-1]
- Moved from using Fryguy_ to Ryan Weaver
  Signing RPM with PGP now.
- 3.1 beta 1  November 19, 1998
  New:
	- GL_EXT_stencil_wrap extension
	- GL_INGR_blend_func_separate extension
	- GL_ARB_multitexture extension
	- GL_NV_texgen_reflection
	- newly optimized vertex transformation code
	- updated GLUT 3.7 code
	- better precision when using 32-bit Z buffer
	- Allegro DJGPP driver
  Bug fixes:
	- glCopyPixels between front/back buffers didn't copy alpha correctly
	- fixed out-of-bounds memory access in optimized 2-D texture code
	- glPixelStorei didn't accept GL_PACK/UNPACK_IMAGE_HEIGHT parameter
	- glGet*() didn't accept GL_MAX_3D_TEXTURE_SIZE parameter
	- clipping of texture coordinates sometimes had bad R,Q values
	- GL_CLAMP_TO_EDGE texture sampling was off by 0.5 texels
	- glEdgeFlagPointer() now takes a GLvoid * instead of GLboolean *
	- texture was sometimes applied twice with 3Dfx driver
	- glPush/PopAttrib() fouled up texture object reference counts
	- glDeleteLists(0, n) caused assertion failure
	- bilinear texture sampling wasn't accurate enough
	- glClear w/ glDepthMask(GL_FALSE) didn't work right on 3Dfx
	- color components were reversed on big endian 32 bpp X visuals
  Changes:
	- removed GL_EXT_multitexture extension

* Mon Oct 26 1998 Fryguy_ <fryguy@falehope.co>
  [Mesa-3.0-2]
- Added patches to 3.0 from the ftp site.
- 3.0  September 17, 1998
  New:
	- OpenGL 1.2 API
	- GL_EXT_abgr pixel format extension
	- GL_SGIS_texture_edge_clamp extension
	- GL_SGIS_multitexture extension (to be replaced by GL_ARB_multitex)
	- GL_EXT_multitexture extension (to be replaced by GL_ARB_multitex)
	- GL_EXT_rescale_normal extension and renormal.c demo
	- GLX_SGI_video_sync extension (a no-op)
	- antialiased lines
	- glGetTexImage() now implemented
	- glDraw/Copy/ReadPixels() optimizations
	- optimized textured triangle code (Marten Stromberg)
	- more optimization of dithered TrueColor triangles in X driver
	- Linux GGI driver
	- updated MGL driver
  Bug fixes:
	- lots of assorted compilation fixes
	- glInitNames didn't write initial hit record
	- glBitmap didn't always check for invalid raster position
	- switching between GLX and OSMesa contexts caused a crash
	- fixed uninitialized variable in Mesa widget code
	- fixed typo in texture code which caused book/texgen to crash
	- fixed texture sampling bug when filter=GL_LINEAR and wrap=GL_CLAMP
	- gluDisk() in POINT or LINE mode sometimes failed
	- fixed texture + fog bug
	- GL_COMPILE_AND_EXECUTE mode didn't work reliably
	- glMultMatrix in projection matrix mode w/ 3Dfx driver could fail
	- glDrawPixels(color index pixels) weren't converted to RGBA
	- fixed possible getenv() buffer overflow security bug
	- glBitmap in feedback mode was offset by xOrig, yOrig params
	- device driver's DrawPixels hook was never used
	- glDrawPixels with zoomY!=1 and top/bottom clipping didn't work
	- glDrawPixels optimized for GL_LUMINANCE, GL_LUMINANCE_ALPHA, GLubyte
	- fixed MakeCurrent bug in GLwRedrawObjects() in MesaWorkstation.c
	- glCopyTexSubImage2D() didn't work with 3Dfx driver
	- lines with width = 2 could cause crash
	- glClear with scissor rect sometimes cleared whole buffer
	- glTexSubImage2D( .. GL_COLOR_INDEX .. ) didn't work
	- glTexImageXD( .. GL_ABGR_EXT .. ) didn't work
	- computation of inverse modelview matrix sometimes failed
	- fixed GL_CLAMP mode texture sampling bug
	- textured line interpolation was somewhat broken
	- textured triangle interpolation was also somewhat broken
	- glGet(MODELVIEW/PROJECTION/TEXTURE_MATRIX_STACK_DEPTH) off by one
	- evaluator state wasn't fully initialized
	- texture coordinate clipping was buggy
	- evaluator surfaces could be mis-colored
	- glAccum(GL_RETURN, s) didn't obey glColorMask() settings
	- zero area polygons shouldn't be culled if polygon mode is point/line
	- clipped width and height of glReadPixels was sometimes off by one
	- blending with alpha = 0 or 1.0 wasn't always exact
	- reading of pixels from clipped region was buggy
	- minor tweaking of X visual management in GLX emulator
	- glPolygonStipple now obeys pixel unpacking parameters
	- glGetPolygonStipple now obeys pixel packing parameters
	- interleaved vertex array texture coordinates were broken
	- query of proxy texture internal format was broken
	- alpha channel wasn't reliably cleared
	- fixed divide by zero error in gluScaleImage if dest size = 1 x 1
  Conformance bug fixes:
	- GL_SELECTION_BUFFER_POINTER and GL_SELECTION_BUFFER_SIZE were missing
	- GL_TEXTURE_INTERNAL_FORMAT was missing
	- glGet*(GL_POLYGON_STIPPLE) was broken
	- glPush/PopAttrib() didn't save/restore all texture state
	- glBitmap in feedback mode didn't work
	- feedback of texture coords didn't always work
	- glDrawPixels w/ format=GL_DEPTH_COMPONENT, type=GLbyte was broke
	- glDrawPixels w/ format=GL_DEPTH_COMPONENT, type=GLubyte was broke
	- glDrawPixels w/ format=GL_STENCIL_INDEX, type=GL_BITMAP was broke
  Changes:
	- upgraded GLUT to version 3.7
	- only GL and GLU library code included in MesaLib.tar.gz
	- GLUT and all demos now in MesaDemos.tar.gz
	- glaux and gltk libraries removed
	- IRIX -n32 and -64 libs go in lib32/ and lib64/ directories
